
; =============================================================================
; SNES code - Normal version
; =============================================================================


; Asar directives
hirom
org $C39F5C


; Determine whether to trigger Reequip in Relic menu
C39F5C:  JSR $93F2       ; Define Y...
         STZ $99         ; Reequip: No
         STZ $FE         ; Clear old FX
         STZ $FF         ; Clear new FX
         LDX #$0002      ; 1st: M.Award

; Fork: Handle current Reequip item
.loop    LDA.L reeqitm,X ; Reequip item

; Fork: Check if among old equipment
         CMP $B0         ; Old relic 1?
         BEQ .found1     ; Branch if so
         CMP $B1         ; Old relic 2?
         BEQ .found1     ; Branch if so
         CLC             ; Clear Carry
.found1  ROL $FE         ; Old FX x2 + C

; Fork: Check if among new equipment
         CMP $0023,Y     ; New relic 1?
         BEQ .found2     ; Branch if so
         CMP $0024,Y     ; New relic 2?
         BEQ .found2     ; Branch if so
         CLC             ; Clear Carry
.found2  ROL $FF         ; New FX x2 + C

; Fork: Handle next Reequip item
         DEX             ; Table index -1
         BPL .loop       ; Loop till < 0

; Fork: Compare old and new relic effects
         LDA $FE         ; Old effects
         CMP $FF         ; New effects
         BEQ .exit       ; Abort if same
         INC $99         ; Reequip: Yes
.exit    RTS

; Relics that trigger Reequip
reeqitm: db $D0          ; Gauntlet
         db $D1          ; Genji Glove
         db $DA          ; Merit Award


warnpc $C39FB1


; =============================================================================
; SNES code - Alternative version
; =============================================================================


; Asar directives
hirom
org $C39F5C


; Determine whether to trigger Reequip in Relic menu
C39F5C:  JSR $93F2       ; Define Y...
         STZ $99         ; Reequip: No
         STZ $FE         ; Clear old FX
         STZ $FF         ; Clear new FX
         LDX #$0001      ; 1st: M.Award

; Fork: Handle current Reequip item
.loop    LDA.L reeqitm,X ; Reequip item

; Fork: Check if among old equipment
         CMP $B0         ; Old relic 1?
         BEQ .found1     ; Branch if so
         CMP $B1         ; Old relic 2?
         BEQ .found1     ; Branch if so
         CLC             ; Clear Carry
.found1  ROL $FE         ; Old FX x2 + C

; Fork: Check if among new equipment
         CMP $0023,Y     ; New relic 1?
         BEQ .found2     ; Branch if so
         CMP $0024,Y     ; New relic 2?
         BEQ .found2     ; Branch if so
         CLC             ; Clear Carry
.found2  ROL $FF         ; New FX x2 + C

; Fork: Handle next Reequip item
         DEX             ; Table index -1
         BPL .loop       ; Loop till < 0

; Fork: Check if either relic effect was lost
         LDA $FE         ; Old effects
         AND $FF         ; Clear lost ones
         CMP $FE         ; Lost neither?
         BEQ .exit       ; Abort if so
         INC $99         ; Reequip: Yes
.exit    RTS

; Relics that trigger Reequip
reeqitm: db $D1          ; Genji Glove
         db $DA          ; Merit Award


warnpc $C39FB1
